Index: /codes/icosagcm/trunk/src/icosa_init.f90
===================================================================
--- /codes/icosagcm/trunk/src/icosa_init.f90	(revision 1024)
+++ /codes/icosagcm/trunk/src/icosa_init.f90	(revision 1025)
@@ -17,5 +17,5 @@
   USE write_field_mod
   USE physics_mod
-  USE tracer_mod
+  USE tracer_icosa_mod
   USE restart_mod
   USE etat0_mod
Index: /codes/icosagcm/trunk/src/initial/etat0_dcmip2016_baroclinic_wave.f90
===================================================================
--- /codes/icosagcm/trunk/src/initial/etat0_dcmip2016_baroclinic_wave.f90	(revision 1024)
+++ /codes/icosagcm/trunk/src/initial/etat0_dcmip2016_baroclinic_wave.f90	(revision 1025)
@@ -13,5 +13,5 @@
   SUBROUTINE getin_etat0
     USE mpipara, ONLY : is_mpi_root
-    USE tracer_mod
+    USE tracer_icosa_mod
     IMPLICIT NONE
     CHARACTER(LEN=255) :: str_perturbation
Index: /codes/icosagcm/trunk/src/initial/etat0_dcmip2016_supercell.f90
===================================================================
--- /codes/icosagcm/trunk/src/initial/etat0_dcmip2016_supercell.f90	(revision 1024)
+++ /codes/icosagcm/trunk/src/initial/etat0_dcmip2016_supercell.f90	(revision 1025)
@@ -10,5 +10,5 @@
   SUBROUTINE getin_etat0
     USE mpipara, ONLY : is_mpi_root
-    USE tracer_mod
+    USE tracer_icosa_mod
     USE dcmip2016_supercell_mod, ONLY : supercell_init, supercell_test
     IF(nqtot<5) THEN
Index: /codes/icosagcm/trunk/src/transport/advect_tracer.F90
===================================================================
--- /codes/icosagcm/trunk/src/transport/advect_tracer.F90	(revision 1024)
+++ /codes/icosagcm/trunk/src/transport/advect_tracer.F90	(revision 1025)
@@ -63,5 +63,5 @@
     USE trace
     USE write_field_mod
-    USE tracer_mod
+    USE tracer_icosa_mod
     USE abort_mod
     TYPE(t_field),POINTER :: f_hfluxt(:)   ! time-integrated horizontal mass flux
Index: des/icosagcm/trunk/src/transport/tracer.f90
===================================================================
--- /codes/icosagcm/trunk/src/transport/tracer.f90	(revision 1024)
+++ 	(revision )
@@ -1,41 +1,0 @@
-MODULE tracer_mod
-
-  INTEGER, PARAMETER   :: advect_none    = 0
-  INTEGER, PARAMETER   :: advect_vanleer = 1
-  INTEGER, ALLOCATABLE,SAVE :: advection_scheme(:)
-!$OMP THREADPRIVATE(advection_scheme)
- 
-  INTERFACE set_advection_scheme
-    MODULE PROCEDURE set_advection_scheme_1, set_advection_scheme_full
-  END INTERFACE
-
-CONTAINS
-
-  SUBROUTINE init_tracer
-  USE grid_param
-  IMPLICIT NONE
-    
-    ALLOCATE(advection_scheme(nqtot))
-    advection_scheme(:) = advect_vanleer 
-
-  END SUBROUTINE init_tracer
-
-  SUBROUTINE set_advection_scheme_1(nq,scheme)
-  IMPLICIT NONE
-    INTEGER, INTENT(IN) :: nq
-    INTEGER, INTENT(IN) :: scheme
-    
-    advection_scheme(nq)=scheme
-  
-  END SUBROUTINE set_advection_scheme_1
-
-  SUBROUTINE set_advection_scheme_full(schemes)
-  USE grid_param
-  IMPLICIT NONE
-    INTEGER, INTENT(IN) :: schemes(nqtot)
-  
-    advection_scheme(:)=schemes(:)
-  
-  END SUBROUTINE set_advection_scheme_full
-
-END MODULE tracer_mod
Index: /codes/icosagcm/trunk/src/transport/tracer_icosa.f90
===================================================================
--- /codes/icosagcm/trunk/src/transport/tracer_icosa.f90	(revision 1025)
+++ /codes/icosagcm/trunk/src/transport/tracer_icosa.f90	(revision 1025)
@@ -0,0 +1,41 @@
+MODULE tracer_icosa_mod
+
+  INTEGER, PARAMETER   :: advect_none    = 0
+  INTEGER, PARAMETER   :: advect_vanleer = 1
+  INTEGER, ALLOCATABLE,SAVE :: advection_scheme(:)
+!$OMP THREADPRIVATE(advection_scheme)
+ 
+  INTERFACE set_advection_scheme
+    MODULE PROCEDURE set_advection_scheme_1, set_advection_scheme_full
+  END INTERFACE
+
+CONTAINS
+
+  SUBROUTINE init_tracer
+  USE grid_param
+  IMPLICIT NONE
+    
+    ALLOCATE(advection_scheme(nqtot))
+    advection_scheme(:) = advect_vanleer 
+
+  END SUBROUTINE init_tracer
+
+  SUBROUTINE set_advection_scheme_1(nq,scheme)
+  IMPLICIT NONE
+    INTEGER, INTENT(IN) :: nq
+    INTEGER, INTENT(IN) :: scheme
+    
+    advection_scheme(nq)=scheme
+  
+  END SUBROUTINE set_advection_scheme_1
+
+  SUBROUTINE set_advection_scheme_full(schemes)
+  USE grid_param
+  IMPLICIT NONE
+    INTEGER, INTENT(IN) :: schemes(nqtot)
+  
+    advection_scheme(:)=schemes(:)
+  
+  END SUBROUTINE set_advection_scheme_full
+
+END MODULE tracer_icosa_mod