Index: codes/icosagcm/devel/xml/context_dynamico.xml
===================================================================
--- codes/icosagcm/devel/xml/context_dynamico.xml	(revision 1035)
+++ codes/icosagcm/devel/xml/context_dynamico.xml	(revision 1037)
@@ -14,7 +14,8 @@
 
   <!-- =========================================================================================================== -->
-  <!-- Definition of output files in file_def_dynamico.xml, not including restart files                            -->
+  <!-- Definition of output files in file_def_dynamico_*.xml, not including restart files                            -->
   <!-- =========================================================================================================== -->
-  <file_definition src="./file_def_dynamico.xml" />  
+  <file_definition src="./file_def_dynamico_native.xml" />  
+  <file_definition src="./file_def_dynamico_regular.xml" />  
 
   <!-- =========================================================================================================== -->
@@ -55,11 +56,10 @@
        <field_group id="group_restart" operation="once"> 
           <field id="it_restart" name="iteration"  grid_ref="scalar" />
-          <field id="q_restart" name="q"  grid_ref="grid_q" />
-
-          <field id="xcell_restart" name="xcell" domain_ref="i" prec="8"/>
-          <field id="ycell_restart" name="ycell" domain_ref="i" prec="8"/>
-          <field id="zcell_restart" name="zcell" domain_ref="i" prec="8"/>
-
-          <field_group domain_ref="i"> 
+          <field id="q_restart" name="q"  grid_ref="grid_q" prec="8"/>
+     
+          <field_group domain_ref="i" prec="8"> 
+             <field id="xcell_restart" name="xcell" />
+             <field id="ycell_restart" name="ycell" />
+             <field id="zcell_restart" name="zcell" />
              <field id="ps_restart" name="ps" />
              <field id="phis_restart" name="phis" />
@@ -77,10 +77,10 @@
        <field_group id="group_start" operation="once"> 
           <field id="it_start" name="iteration"  grid_ref="scalar" />
-          <field_group domain_ref="i"> 
+          <field_group domain_ref="i" prec="8"> 
+             <field id="xcell_start" name="xcell" />
+             <field id="ycell_start" name="ycell" />
+             <field id="zcell_start" name="zcell" />
              <field id="ps_start" name="ps" />
              <field id="phis_start" name="phis" />
-             <field id="xcell_start" name="xcell" domain_ref="i" prec="8"/>
-             <field id="ycell_start" name="ycell" domain_ref="i" prec="8"/>
-             <field id="zcell_start" name="zcell" domain_ref="i" prec="8"/>
              <field_group axis_ref="lev" >
                 <field id="theta_rhodz_start" name="theta_rhodz" />
@@ -90,5 +90,5 @@
              </field_group>
           </field_group>
-          <field id="q_start" name="q"  grid_ref="grid_q" />
+          <field id="q_start" name="q"  grid_ref="grid_q" prec="8"/>
        </field_group>
     </file>
@@ -121,17 +121,15 @@
   <!-- Axis definitions                                                                                            -->
   <!-- =========================================================================================================== -->
-  <axis_definition>
+  <axis_definition prec="8">
     <axis id="lev" name="lev" positive="down" standard_name="atmopshere_hybrid_sigma_pressure_coordinate" long_name="hybrid level at midpoints" />
     <axis id="levp1" name="ilev"  unit="level" positive="down" standard_name="atmopshere_hybride_sigma_pressure_coordinate" long_name="hybrid level at interface" />
     <axis id="lev_pressure" positive="down"  n_glo="2" unit="Pa" value="(0,1)[85000 50000]" >
       <interpolate_axis order="1" coordinate="p" />
-    </axis>    
+    </axis>
+    <axis id="presnivs_mb" > 
+      <interpolate_axis order="1" /> 
+    </axis>
     <axis id="nq" name="nq" n_glo="6" value="(0,5)[1 2 3 4 5 6]"/>
     <axis id="lev_ecdyn" />
-
-    <axis id="lev_guided" />
-    <axis id="presnivs_mb" >
-      <interpolate_axis order="2" /> 
-    </axis>
   </axis_definition>    
   
@@ -140,5 +138,5 @@
   <!-- Domain definitions                                                                                          -->
   <!-- =========================================================================================================== -->
-  <domain_definition>
+  <domain_definition prec="8">
 
     <domain_group id="i"> 
@@ -152,9 +150,4 @@
         <interpolate_domain/>
       </domain>
-      
-     <domain id="from_guided" >
-       <interpolate_domain order="2"/>
-     </domain>
-
     </domain_group> 
 
@@ -184,8 +177,4 @@
       <generate_rectilinear_domain />
     </domain>
-
-       <domain id="domain_guided" type="rectilinear">
-         <generate_rectilinear_domain />
-       </domain> 
     
   </domain_definition>    
Index: codes/icosagcm/devel/xml/field_def_dynamico.xml
===================================================================
--- codes/icosagcm/devel/xml/field_def_dynamico.xml	(revision 1035)
+++ codes/icosagcm/devel/xml/field_def_dynamico.xml	(revision 1037)
@@ -38,8 +38,4 @@
         <field id="omega"/>
         <field id="temp"/>
-        <field id="kinetic_trisk"/>
-        <field id="kinetic"/>
-        <field id="kinetic_trisk_init"/>
-        <field id="kinetic_init"/>
         <field id="dulon_diss1"/>
         <field id="dulat_diss1"/>
@@ -49,5 +45,5 @@
         <field id="dulat_phys"/>
 
-        <field id="mass_t"           long_name="Time-averaged air mass"   unit="kg/m2"/>
+	<field id="mass_t"           long_name="Time-averaged air mass"   unit="kg/m2"/>
         <field id="massflux_lon"     long_name="Time-averaged air mass flux, zonal"   unit="kg/m/s"/>
         <field id="massflux_lat"     long_name="Time-averaged air mass flux, meridional"   unit="kg/m/s"/>
@@ -109,8 +105,14 @@
         <field id="geopot_init"/>
       </field_group>
+    </field_group>
+
+    <field_group grid_ref="grid_q">
+      <field id="q_init" />
+      <field id="q" />
+      <field id="qmass_t" />
+      <field id="qflux_lon" />
+      <field id="qflux_lat" />
     </field_group> 
-    <field id="q_init" grid_ref="grid_q" />    
-    <field id="q" grid_ref="grid_q" />    
-    
+
     <field_group domain_ref="v" axis_ref="lev">
       <field id="vort" />
Index: codes/icosagcm/devel/xml/file_def_dynamico.xml
===================================================================
--- codes/icosagcm/devel/xml/file_def_dynamico.xml	(revision 1035)
+++ 	(revision )
@@ -1,83 +1,0 @@
-<!-- =========================================================================================================== -->
-<!-- file_def_dynamico                                                                                           -->
-<!-- Definition of output diagnostic files (not including restart files)                                         -->
-<!-- =========================================================================================================== -->
-<file_definition > 
-
-  <file id="output_dcmip2016_native" convention="CF" enabled="false" output_freq="3h" sync_freq="3h" output_level="10" timeseries="none" description="Dry baroclinic wave" > 
-    
-    <field_group id="dcmip2016_output_field_once" operation="once" freq_offset="0ts" ts_enabled="true">
-      <field field_ref="timestep" name="mdt" enabled="false" />
-      <field field_ref="preff" name="P0" long_name="reference pressure" />
-      <field field_ref="ap" name="hyai"   />
-      <field field_ref="bp" name="hybi"   />
-      <field field_ref="mid_ap" name="hyam"   />
-      <field field_ref="mid_bp" name="hybm"   />
-    </field_group>
-    
-    
-    <field_group id="dcmip2016_output_field" ts_enabled="true">
-      <field field_ref="ps" name="PS"       standard_name="surface_pressure" long_name="Surface pressure"         unit="Pa" />
-      <field field_ref="phis" operation="once" freq_offset="0ts" name="PHIS"   standard_name="surface_geopotential" long_name="Surface geopotential" unit="m2/m2"/>
-      <field field_ref="geopot"  name="PHI"   standard_name="geopotential" long_name="geopotential" unit="m2/s2"/>
-      <field field_ref="ulon" name="U"      standard_name="eastward_wind" long_name="Zonal wind"                  unit="m/s"/>
-      <field field_ref="ulat" name="V"      standard_name="northward_wind" long_name="Meridional wind"            unit="m/s"/>
-      <field field_ref="uz" name="W"        standard_name="upward_air_velocity" long_name="Vertical velocity"     unit="m/s"/>
-      <field field_ref="omega" name="OMEGA"        standard_name="lagrangian_tendency_of_air_pressure" long_name="Vertical pressure velocity"     unit="Pa/s"/>
-      <field field_ref="p"  name="P"        standard_name="air_pressure" long_name="Pressure"     unit="Pa"/>
-      <field field_ref="temp"  name="T"        standard_name="air_temperature" long_name="Temperature"     unit="K"/>
-<!--
-      <field field_ref="q1"  name="Q"        standard_name="specific_humidity"  long_name="Specific humidity"          unit="kg/kg"/>
-      <field field_ref="q2"  name="Qc"                                          long_name="Cloud water mixing ration"  unit="kg/kg"/>
-      <field field_ref="q3"  name="Qr"                                          long_name="Rain water mixing ration"  unit="kg/kg"/>
--->
-      <field field_ref="precl"  name="PRECT"     standard_name="rainfall_rate"  long_name="Large Scale precipitation rate"  unit="m/s"/>
-<!--
-      <field field_ref="q4"  name="Q1"      long_name="Single chlorine mixing ratio"  unit="kg/kg"/> 
-      <field field_ref="q5"  name="Q2"      long_name="Chlorine gas mixing ratio"  unit="kg/kg"/> 
--->
-      <field field_ref="Q1_col_int"  name="Q1_col_int"      long_name="Single chlorine column integrated mixing ratio"  unit="kg/m2"/> 
-      <field field_ref="Q2_col_int"  name="Q2_col_int"      long_name="Chlorine gas column integrated mixing ratio"  unit="kg/m2"/> 
-      <field field_ref="u850" name="U850"       long_name="Zonal wind at 850 hPa"      unit="m/s"/>
-      <field field_ref="v850" name="V850"       long_name="Meridional wind at 850 hPa"   unit="m/s"/>
-      <field field_ref="w850" name="W850"       long_name="Vertical velocity at 850 hPa"     unit="m/s"/>
-      <field field_ref="t850" name="T850"       long_name="Temperature at 850 hPa"   unit="K"/>
-      <field field_ref="omega850" name="OMEGA850"   long_name="Vertical pressure velocity at 850 hPa"     unit="Pa/s"/>
-      <field field_ref="u500" name="U500"       long_name="Zonal wind at 500 hPa"      unit="m/s"/>
-      <field field_ref="v500" name="V500"       long_name="Meridional wind at 850 hPa"   unit="m/s"/>
-      <field field_ref="w850" name="W500"       long_name="Vertical velocity at 500 hPa"     unit="m/s"/>
-      <field field_ref="t500" name="T500"       long_name="Temperature at 850 hPa"   unit="K"/>
-      <field field_ref="omega500" name="OMEGA500"   long_name="Vertical pressure velocity at 500 hPa"     unit="Pa/s"/>
-      <field field_ref="SST" name="SST"       long_name="Sea surface temperature"   unit="K"/>
-      
-    </field_group>
-
-    <variable name="model" type="string" > dynamico </variable>
-    <variable name="test_case" type="string" > 161_dry </variable>
-    <variable name="horizontal_resolution" type="string" > 1 degree native (grid points : 80x80x10) </variable>
-    <variable name="levels" type="string" > L30 </variable>
-    <variable name="grid" type="string" > hex </variable>
-    <variable name="equation" type="string" > hydro </variable>
-    <variable name="time_frequency" type="string" > 3hr </variable>    
-
-  </file>
-
-
-  <file id="output_dcmip2016_regular" enabled="false" output_freq="3h" sync_freq="3h" output_level="10" description="Dry baroclinic wave" timeseries="none" > 
-    
-    <field_group group_ref="dcmip2016_output_field_once"/>
-    
-    <field_group group_ref="dcmip2016_output_field" domain_ref="regular_one_degree" />
-
-    <variable name="model" type="string" > dynamico </variable>
-    <variable name="test_case" type="string" > 161_dry </variable>
-    <variable name="horizontal_resolution" type="string" > 1 degree interpolated (grid points : 80x80x10) </variable>
-    <variable name="levels" type="string" > L30 </variable>
-    <variable name="grid" type="string" > hex </variable>
-    <variable name="equation" type="string" > hydro </variable>
-    <variable name="time_frequency" type="string" > 3hr </variable>    
-
-  </file>
-
-
-</file_definition>
Index: codes/icosagcm/devel/xml/file_def_dynamico_native.xml
===================================================================
--- codes/icosagcm/devel/xml/file_def_dynamico_native.xml	(revision 1037)
+++ codes/icosagcm/devel/xml/file_def_dynamico_native.xml	(revision 1037)
@@ -0,0 +1,65 @@
+<!-- =========================================================================================================== -->
+<!-- file_def_dynamico                                                                                           -->
+<!-- Definition of output diagnostic files (not including restart files)                                         -->
+<!-- =========================================================================================================== -->
+<file_definition > 
+
+  <file id="output_dcmip2016_native" convention="CF" enabled="false" output_freq="3h" sync_freq="3h" output_level="10" timeseries="none" description="Dry baroclinic wave" > 
+    
+    <field_group id="dcmip2016_output_field_once" operation="once" freq_offset="0ts" ts_enabled="true">
+      <field field_ref="timestep" name="mdt" enabled="false" />
+      <field field_ref="preff" name="P0" long_name="reference pressure" />
+      <field field_ref="ap" name="hyai"   />
+      <field field_ref="bp" name="hybi"   />
+      <field field_ref="mid_ap" name="hyam"   />
+      <field field_ref="mid_bp" name="hybm"   />
+    </field_group>
+    
+    
+    <field_group id="dcmip2016_output_field" ts_enabled="true">
+      <field field_ref="ps" name="PS"       standard_name="surface_pressure" long_name="Surface pressure"         unit="Pa" />
+      <field field_ref="phis" operation="once" freq_offset="0ts" name="PHIS"   standard_name="surface_geopotential" long_name="Surface geopotential" unit="m2/m2"/>
+      <field field_ref="geopot"  name="PHI"   standard_name="geopotential" long_name="geopotential" unit="m2/s2"/>
+      <field field_ref="ulon" name="U"      standard_name="eastward_wind" long_name="Zonal wind"                  unit="m/s"/>
+      <field field_ref="ulat" name="V"      standard_name="northward_wind" long_name="Meridional wind"            unit="m/s"/>
+      <field field_ref="uz" name="W"        standard_name="upward_air_velocity" long_name="Vertical velocity"     unit="m/s"/>
+      <field field_ref="omega" name="OMEGA"        standard_name="lagrangian_tendency_of_air_pressure" long_name="Vertical pressure velocity"     unit="Pa/s"/>
+      <field field_ref="p"  name="P"        standard_name="air_pressure" long_name="Pressure"     unit="Pa"/>
+      <field field_ref="temp"  name="T"        standard_name="air_temperature" long_name="Temperature"     unit="K"/>
+<!--
+      <field field_ref="q1"  name="Q"        standard_name="specific_humidity"  long_name="Specific humidity"          unit="kg/kg"/>
+      <field field_ref="q2"  name="Qc"                                          long_name="Cloud water mixing ration"  unit="kg/kg"/>
+      <field field_ref="q3"  name="Qr"                                          long_name="Rain water mixing ration"  unit="kg/kg"/>
+-->
+      <field field_ref="precl"  name="PRECT"     standard_name="rainfall_rate"  long_name="Large Scale precipitation rate"  unit="m/s"/>
+<!--
+      <field field_ref="q4"  name="Q1"      long_name="Single chlorine mixing ratio"  unit="kg/kg"/> 
+      <field field_ref="q5"  name="Q2"      long_name="Chlorine gas mixing ratio"  unit="kg/kg"/> 
+-->
+      <field field_ref="Q1_col_int"  name="Q1_col_int"      long_name="Single chlorine column integrated mixing ratio"  unit="kg/m2"/> 
+      <field field_ref="Q2_col_int"  name="Q2_col_int"      long_name="Chlorine gas column integrated mixing ratio"  unit="kg/m2"/> 
+      <field field_ref="u850" name="U850"       long_name="Zonal wind at 850 hPa"      unit="m/s"/>
+      <field field_ref="v850" name="V850"       long_name="Meridional wind at 850 hPa"   unit="m/s"/>
+      <field field_ref="w850" name="W850"       long_name="Vertical velocity at 850 hPa"     unit="m/s"/>
+      <field field_ref="t850" name="T850"       long_name="Temperature at 850 hPa"   unit="K"/>
+      <field field_ref="omega850" name="OMEGA850"   long_name="Vertical pressure velocity at 850 hPa"     unit="Pa/s"/>
+      <field field_ref="u500" name="U500"       long_name="Zonal wind at 500 hPa"      unit="m/s"/>
+      <field field_ref="v500" name="V500"       long_name="Meridional wind at 850 hPa"   unit="m/s"/>
+      <field field_ref="w850" name="W500"       long_name="Vertical velocity at 500 hPa"     unit="m/s"/>
+      <field field_ref="t500" name="T500"       long_name="Temperature at 850 hPa"   unit="K"/>
+      <field field_ref="omega500" name="OMEGA500"   long_name="Vertical pressure velocity at 500 hPa"     unit="Pa/s"/>
+      <field field_ref="SST" name="SST"       long_name="Sea surface temperature"   unit="K"/>
+      
+    </field_group>
+
+    <variable name="model" type="string" > dynamico </variable>
+    <variable name="test_case" type="string" > 161_dry </variable>
+    <variable name="horizontal_resolution" type="string" > 1 degree native (grid points : 80x80x10) </variable>
+    <variable name="levels" type="string" > L30 </variable>
+    <variable name="grid" type="string" > hex </variable>
+    <variable name="equation" type="string" > hydro </variable>
+    <variable name="time_frequency" type="string" > 3hr </variable>    
+
+  </file>
+
+</file_definition>
Index: codes/icosagcm/devel/xml/file_def_dynamico_regular.xml
===================================================================
--- codes/icosagcm/devel/xml/file_def_dynamico_regular.xml	(revision 1037)
+++ codes/icosagcm/devel/xml/file_def_dynamico_regular.xml	(revision 1037)
@@ -0,0 +1,24 @@
+<!-- =========================================================================================================== -->
+<!-- file_def_dynamico                                                                                           -->
+<!-- Definition of output diagnostic files (not including restart files)                                         -->
+<!-- =========================================================================================================== -->
+<file_definition > 
+
+  <file id="output_dcmip2016_regular" enabled="false" output_freq="3h" sync_freq="3h" output_level="10" description="Dry baroclinic wave" timeseries="none" > 
+    
+    <field_group group_ref="dcmip2016_output_field_once"/>
+    
+    <field_group group_ref="dcmip2016_output_field" domain_ref="regular_one_degree" />
+
+    <variable name="model" type="string" > dynamico </variable>
+    <variable name="test_case" type="string" > 161_dry </variable>
+    <variable name="horizontal_resolution" type="string" > 1 degree interpolated (grid points : 80x80x10) </variable>
+    <variable name="levels" type="string" > L30 </variable>
+    <variable name="grid" type="string" > hex </variable>
+    <variable name="equation" type="string" > hydro </variable>
+    <variable name="time_frequency" type="string" > 3hr </variable>    
+
+  </file>
+
+
+</file_definition>